import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
export declare class CheckboxComponent implements ControlValueAccessor {
    private readonly cdr;
    onClick(ev: Event): void;
    id: string;
    name?: string;
    diameter: string;
    set value(value: boolean);
    get value(): boolean;
    set indeterminate(value: boolean);
    get indeterminate(): boolean;
    tabindex: number;
    disabled: boolean;
    round: boolean;
    change: EventEmitter<Event>;
    checkedChange: EventEmitter<boolean>;
    indeterminateChange: EventEmitter<boolean>;
    blur: EventEmitter<FocusEvent>;
    focus: EventEmitter<FocusEvent>;
    private _value;
    private _indeterminate;
    constructor(cdr: ChangeDetectorRef);
    onBlur(_: any): void;
    onKeyup(ev: Event): void;
    toggle(): void;
    writeValue(value: boolean): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(disabled: boolean): void;
    private onTouchedCallback;
    private onChangeCallback;
    private emitChange;
    static ɵfac: i0.ɵɵFactoryDeclaration<CheckboxComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CheckboxComponent, "ngx-checkbox", ["ngxCheckbox"], { "id": { "alias": "id"; "required": false; }; "name": { "alias": "name"; "required": false; }; "diameter": { "alias": "diameter"; "required": false; }; "value": { "alias": "checked"; "required": false; }; "indeterminate": { "alias": "indeterminate"; "required": false; }; "tabindex": { "alias": "tabindex"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "round": { "alias": "round"; "required": false; }; }, { "change": "change"; "checkedChange": "checkedChange"; "indeterminateChange": "indeterminateChange"; "blur": "blur"; "focus": "focus"; }, never, ["*"], false, never>;
}
