import { AfterViewInit, ElementRef, EventEmitter, OnInit } from '@angular/core';
import { DialogOptions } from '../dialog-options.interface';
import { DialogComponent } from '../dialog.component';
import { AlertTypes } from './alert-types.enum';
import * as i0 from "@angular/core";
export declare class AlertComponent extends DialogComponent implements AfterViewInit, OnInit {
    type: AlertTypes;
    data: any;
    confirmButtonText: string;
    confirmButtonClass: string | string[];
    cancelButtonText: string;
    cancelButtonClass: string | string[];
    get longPress(): boolean;
    set longPress(longPress: boolean);
    ok: EventEmitter<{
        data: any;
    }>;
    cancel: EventEmitter<{
        data: any;
    }>;
    readonly dialogElm: ElementRef<HTMLDivElement>;
    readonly AlertTypes: typeof AlertTypes;
    readonly defaults: DialogOptions;
    private _longPress?;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    onOkClick(): void;
    onCancelClick(): void;
    onKeydown(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AlertComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AlertComponent, "ngx-alert-dialog", ["ngxAlertDialog"], { "type": { "alias": "type"; "required": false; }; "data": { "alias": "data"; "required": false; }; "confirmButtonText": { "alias": "confirmButtonText"; "required": false; }; "confirmButtonClass": { "alias": "confirmButtonClass"; "required": false; }; "cancelButtonText": { "alias": "cancelButtonText"; "required": false; }; "cancelButtonClass": { "alias": "cancelButtonClass"; "required": false; }; "longPress": { "alias": "longPress"; "required": false; }; }, { "ok": "ok"; "cancel": "cancel"; }, never, never, false, never>;
}
