import { ElementRef, EventEmitter, OnDestroy, OnInit, Renderer2, TemplateRef } from '@angular/core';
import { DialogFormat } from './dialog-format.enum';
import * as i0 from "@angular/core";
export declare class DialogComponent implements OnInit, OnDestroy {
    private readonly element;
    private readonly renderer2;
    id: string;
    title: string;
    dialogTitle: string;
    content: string;
    template: TemplateRef<any>;
    cssClass: string;
    context: any;
    class: string;
    format: DialogFormat;
    get closeOnBlur(): boolean;
    set closeOnBlur(closeOnBlur: boolean);
    get closeOnEscape(): boolean;
    set closeOnEscape(closeOnEscape: boolean);
    get closeButton(): boolean;
    set closeButton(closeButton: boolean);
    get visible(): boolean;
    set visible(visible: boolean);
    get zIndex(): number;
    set zIndex(zIndex: number);
    beforeClose: () => boolean;
    open: EventEmitter<boolean | void>;
    close: EventEmitter<boolean | void>;
    get contentzIndex(): number;
    get visibleState(): "active" | "inactive";
    get canClose(): boolean;
    readonly DialogFormat: typeof DialogFormat;
    private _closeOnBlur?;
    private _closeOnEscape?;
    private _closeButton?;
    private _visible?;
    private _zIndex?;
    constructor(element: ElementRef, renderer2: Renderer2);
    ngOnInit(): void;
    ngOnDestroy(): void;
    show(): void;
    hide(): void;
    onEscapeKeyDown(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DialogComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DialogComponent, "ngx-dialog", ["ngxDialog"], { "id": { "alias": "id"; "required": false; }; "title": { "alias": "title"; "required": false; }; "dialogTitle": { "alias": "dialogTitle"; "required": false; }; "content": { "alias": "content"; "required": false; }; "template": { "alias": "template"; "required": false; }; "cssClass": { "alias": "cssClass"; "required": false; }; "context": { "alias": "context"; "required": false; }; "class": { "alias": "class"; "required": false; }; "format": { "alias": "format"; "required": false; }; "closeOnBlur": { "alias": "closeOnBlur"; "required": false; }; "closeOnEscape": { "alias": "closeOnEscape"; "required": false; }; "closeButton": { "alias": "closeButton"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "zIndex": { "alias": "zIndex"; "required": false; }; "beforeClose": { "alias": "beforeClose"; "required": false; }; }, { "open": "open"; "close": "close"; }, never, ["*"], false, never>;
}
