import { ElementRef, EventEmitter, TemplateRef, OnInit } from '@angular/core';
import { SafeUrl } from '@angular/platform-browser';
import { AlertService } from '../alert/alert.service';
import { DialogOptions } from '../dialog-options.interface';
import { LargeFormatDialogFooterComponent } from './components/large-format-dialog-footer/large-format-dialog-footer.component';
import * as i0 from "@angular/core";
export declare class LargeFormatDialogContentComponent implements OnInit {
    elementRef: ElementRef;
    private readonly alertService;
    dialogTitle: string;
    dialogSubtitle?: string;
    imgSrc?: string | SafeUrl;
    removeImageBackground?: boolean;
    logoTemplate?: TemplateRef<unknown>;
    dialogSubtitleTemplate?: TemplateRef<unknown>;
    format: 'large' | 'medium';
    dialogActionTitle: string;
    dirty: boolean;
    dialogDirtyActionTitle: string;
    dirtyAlertOptions?: DialogOptions;
    skipDirtyAlert: boolean;
    closeOrCancel: EventEmitter<boolean>;
    get isLargeFormat(): boolean;
    get isMediumFormat(): boolean;
    footerComponent?: LargeFormatDialogFooterComponent;
    stepperTemplate?: TemplateRef<unknown>;
    tabsTemplate?: TemplateRef<unknown>;
    myTemplate: ElementRef;
    imageTemplate: {};
    constructor(elementRef: ElementRef, alertService: AlertService);
    ngOnInit(): void;
    onCloseOrCancel(isDirty: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<LargeFormatDialogContentComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<LargeFormatDialogContentComponent, "ngx-large-format-dialog-content, ngx-medium-format-dialog-content", never, { "dialogTitle": { "alias": "dialogTitle"; "required": false; }; "dialogSubtitle": { "alias": "dialogSubtitle"; "required": false; }; "imgSrc": { "alias": "imgSrc"; "required": false; }; "removeImageBackground": { "alias": "removeImageBackground"; "required": false; }; "logoTemplate": { "alias": "logoTemplate"; "required": false; }; "dialogSubtitleTemplate": { "alias": "dialogSubtitleTemplate"; "required": false; }; "format": { "alias": "format"; "required": false; }; "dialogActionTitle": { "alias": "dialogActionTitle"; "required": false; }; "dirty": { "alias": "dirty"; "required": false; }; "dialogDirtyActionTitle": { "alias": "dialogDirtyActionTitle"; "required": false; }; "dirtyAlertOptions": { "alias": "dirtyAlertOptions"; "required": false; }; "skipDirtyAlert": { "alias": "skipDirtyAlert"; "required": false; }; }, { "closeOrCancel": "closeOrCancel"; }, ["footerComponent", "stepperTemplate", "tabsTemplate"], ["*", "ngx-large-format-dialog-footer", "ngx-medium-format-dialog-footer"], false, never>;
}
