import { EventEmitter, OnDestroy, TemplateRef, OnInit, ElementRef } from '@angular/core';
import { DrawerDirection } from './drawer-direction.enum';
import { DrawerPosition } from './drawer-position.enum';
import * as i0 from "@angular/core";
export declare class DrawerComponent implements OnInit, OnDestroy {
    private readonly elementRef;
    cssClass: string;
    direction: DrawerDirection;
    template: TemplateRef<any>;
    context: any;
    isRoot: boolean;
    get size(): number;
    set size(val: number);
    get zIndex(): number;
    set zIndex(val: number);
    get closeOnOutsideClick(): boolean;
    set closeOnOutsideClick(val: boolean);
    close: EventEmitter<boolean>;
    get cssClasses(): string;
    widthSize: string | number;
    heightSize: string | number;
    position: DrawerPosition;
    private get isLeft();
    private get isBottom();
    private _size;
    private _zIndex;
    private _closeOnOutsideClick;
    constructor(elementRef: ElementRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    setDimensions(size: number): void;
    onEscapeKey(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DrawerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DrawerComponent, "ngx-drawer", ["ngxDrawer"], { "cssClass": { "alias": "cssClass"; "required": false; }; "direction": { "alias": "direction"; "required": false; }; "template": { "alias": "template"; "required": false; }; "context": { "alias": "context"; "required": false; }; "isRoot": { "alias": "isRoot"; "required": false; }; "size": { "alias": "size"; "required": false; }; "zIndex": { "alias": "zIndex"; "required": false; }; "closeOnOutsideClick": { "alias": "closeOnOutsideClick"; "required": false; }; }, { "close": "close"; }, never, never, false, never>;
}
