import { ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, Renderer2, TemplateRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import type { QueryList } from '@angular/core';
import { Appearance } from '../../mixins/appearance/appearance.enum';
import { SelectDropdownOption } from '../select/select-dropdown-option.interface';
import { SelectDropdownComponent } from '../select/select-dropdown.component';
import { SelectOptionDirective } from '../select/select-option.directive';
import * as i0 from "@angular/core";
export declare class FilterSelectComponent implements ControlValueAccessor, OnDestroy {
    private readonly _element;
    private readonly _renderer;
    private readonly _cdr;
    id: string;
    name: string;
    label: string;
    placeholder: string;
    emptyPlaceholder: string;
    filterEmptyPlaceholder: string;
    filterPlaceholder: string;
    forceDownwardOpening: boolean;
    groupBy: string;
    options: SelectDropdownOption[];
    identifier: string;
    appearance: Appearance;
    get autosizeMinWidth(): number | string;
    set autosizeMinWidth(autosizeMinWidth: number | string);
    autofocus: boolean;
    autosize: boolean;
    disableDropdown: boolean;
    closeOnSelect: boolean;
    closeOnBodyClick: boolean;
    filterable: boolean;
    filterCaseSensitive: boolean;
    showSelectAll: boolean;
    multiple: boolean;
    disabled: boolean;
    change: EventEmitter<any[]>;
    keyup: EventEmitter<{
        event: KeyboardEvent;
        value?: string;
    }>;
    toggle: EventEmitter<boolean>;
    clearQueryFilter: EventEmitter<void>;
    readonly selectDropdown: SelectDropdownComponent;
    /**
     * Custom Template for groupBy
     * Only works with groupBy on
     *
     * TemplateContext:
     * - groupName: the name of the group (`option.value[this.groupBy]` is the value)
     * - index, first, last, odd, even (ngFor properties)
     */
    groupByTemplate: TemplateRef<unknown>;
    get optionTemplates(): QueryList<SelectOptionDirective>;
    set optionTemplates(val: QueryList<SelectOptionDirective>);
    get isSingleSelect(): boolean;
    get hasSelections(): boolean;
    get hasPlaceholder(): boolean;
    get selection(): string;
    get value(): any[];
    set value(val: any[]);
    get dropdownVisible(): boolean;
    toggleListener?: () => void;
    filterQuery: string;
    focusIndex: number;
    dropdownActive: boolean;
    touched: boolean;
    private _optionTemplates;
    private _value;
    private _selection;
    private _autosizeMinWidth;
    constructor(_element: ElementRef, _renderer: Renderer2, _cdr: ChangeDetectorRef);
    ngOnDestroy(): void;
    onDropdownSelection(selection: SelectDropdownOption, shouldClose?: boolean): void;
    onDropdownDeselection(selection: SelectDropdownOption, shouldClose?: boolean): void;
    private afterSelect;
    onFocus(): void;
    onFocusLast(): void;
    focusOn(index: number): void;
    onClear(): void;
    onBodyClick(event: Event): void;
    onClose(): void;
    onToggle(): void;
    toggleDropdown(state: boolean): void;
    get caretVisible(): boolean;
    get clearVisible(): boolean;
    get hasControls(): boolean;
    onKeyUp({ event, value }: {
        event: KeyboardEvent;
        value?: string;
    }): void;
    onSelectAll(): void;
    writeValue(val: any[]): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    private findIndex;
    private adjustMenuDirection;
    private isIntersectingBottom;
    private isIntersectingTop;
    private onChangeCallback;
    private onTouchedCallback;
    static ɵfac: i0.ɵɵFactoryDeclaration<FilterSelectComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FilterSelectComponent, "ngx-filter-select", ["ngxFilterSelect"], { "id": { "alias": "id"; "required": false; }; "name": { "alias": "name"; "required": false; }; "label": { "alias": "label"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "emptyPlaceholder": { "alias": "emptyPlaceholder"; "required": false; }; "filterEmptyPlaceholder": { "alias": "filterEmptyPlaceholder"; "required": false; }; "filterPlaceholder": { "alias": "filterPlaceholder"; "required": false; }; "forceDownwardOpening": { "alias": "forceDownwardOpening"; "required": false; }; "groupBy": { "alias": "groupBy"; "required": false; }; "options": { "alias": "options"; "required": false; }; "identifier": { "alias": "identifier"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "autosizeMinWidth": { "alias": "autosizeMinWidth"; "required": false; }; "autofocus": { "alias": "autofocus"; "required": false; }; "autosize": { "alias": "autosize"; "required": false; }; "disableDropdown": { "alias": "disableDropdown"; "required": false; }; "closeOnSelect": { "alias": "closeOnSelect"; "required": false; }; "closeOnBodyClick": { "alias": "closeOnBodyClick"; "required": false; }; "filterable": { "alias": "filterable"; "required": false; }; "filterCaseSensitive": { "alias": "filterCaseSensitive"; "required": false; }; "showSelectAll": { "alias": "showSelectAll"; "required": false; }; "multiple": { "alias": "multiple"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "groupByTemplate": { "alias": "groupByTemplate"; "required": false; }; }, { "change": "change"; "keyup": "keyup"; "toggle": "toggle"; "clearQueryFilter": "clearQueryFilter"; }, ["optionTemplates"], never, false, never>;
}
