import { TemplateRef, SimpleChanges, ChangeDetectorRef, OnChanges, OnInit } from '@angular/core';
import { JsonEditorNodeFlatComponent } from './json-editor-node-flat/json-editor-node-flat.component';
import { SchemaValidatorService } from '../schema-validator.service';
import { JsonEditor } from '../json-editor';
import { JSONEditorSchema, JsonSchemaDataType } from '../json-editor.helper';
import { DialogService } from '../../dialog/dialog.service';
import { PropertyConfigComponent, PropertyConfigOptions } from './json-editor-node-flat/node-types/property-config/property-config.component';
import type { QueryList } from '@angular/core';
import * as i0 from "@angular/core";
export declare class JsonEditorFlatComponent extends JsonEditor implements OnInit, OnChanges {
    private dialogService;
    protected schemaValidatorService: SchemaValidatorService;
    protected cdr: ChangeDetectorRef;
    model: any;
    schema: JSONEditorSchema;
    typeCheckOverrides?: any;
    schemaBuilderMode?: boolean;
    formats?: string[];
    hideRoot: boolean;
    showKnownProperties: boolean;
    passwordToggleEnabled: boolean;
    enableSchemaValidation: boolean;
    inputControlTemplate: TemplateRef<unknown>;
    nodeElms: QueryList<JsonEditorNodeFlatComponent>;
    propertyConfigTmpl: TemplateRef<PropertyConfigComponent>;
    schemaRef: JSONEditorSchema;
    customFormats: JsonSchemaDataType[];
    constructor(dialogService: DialogService, schemaValidatorService: SchemaValidatorService, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onPropertyConfig(): void;
    validate(schema: any, model: any): boolean;
    updateSchemaProperty(options: PropertyConfigOptions): void;
    private buildCustomFormats;
    static ɵfac: i0.ɵɵFactoryDeclaration<JsonEditorFlatComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<JsonEditorFlatComponent, "ngx-json-editor-flat", never, { "model": { "alias": "model"; "required": false; }; "schema": { "alias": "schema"; "required": false; }; "typeCheckOverrides": { "alias": "typeCheckOverrides"; "required": false; }; "schemaBuilderMode": { "alias": "schemaBuilderMode"; "required": false; }; "formats": { "alias": "formats"; "required": false; }; "hideRoot": { "alias": "hideRoot"; "required": false; }; "showKnownProperties": { "alias": "showKnownProperties"; "required": false; }; "passwordToggleEnabled": { "alias": "passwordToggleEnabled"; "required": false; }; "enableSchemaValidation": { "alias": "enableSchemaValidation"; "required": false; }; "inputControlTemplate": { "alias": "inputControlTemplate"; "required": false; }; }, {}, ["nodeElms"], never, false, never>;
}
