import { OnInit, EventEmitter, SimpleChanges, OnChanges, TemplateRef, OnDestroy } from '@angular/core';
import { JsonEditorNode } from '../../json-editor-node';
import { DateFormatPipe } from 'ngx-moment';
import { DialogService } from '../../../dialog/dialog.service';
import { JSONEditorSchema, JSONEditorTemplateProperty, JsonSchemaDataType } from '../../json-editor.helper';
import { Subject } from 'rxjs';
import * as i0 from "@angular/core";
export declare class JsonEditorNodeFlatComponent extends JsonEditorNode implements OnInit, OnChanges, OnDestroy {
    dialogMngr: DialogService;
    private dateFormat;
    model: any;
    schema: JSONEditorSchema;
    typeCheckOverrides?: any;
    errors: any[];
    label: string;
    level: number;
    schemaBuilderMode?: boolean;
    schemaRef?: JSONEditorSchema;
    formats: JsonSchemaDataType[];
    arrayItem: boolean;
    hideRoot: boolean;
    arrayName: string;
    indentationArray: number[];
    showKnownProperties: boolean;
    isDuplicated: boolean;
    passwordToggleEnabled: boolean;
    inputControlTemplate: TemplateRef<unknown>;
    updatePropertyNameEvent: EventEmitter<{
        id: string | number;
        name: string;
    }>;
    nextLevel: number;
    contextItem: JSONEditorTemplateProperty;
    nodeChangeValue$: Subject<unknown>;
    nodeExpandTrigger$: Subject<boolean>;
    private readonly unsub$;
    constructor(dialogMngr: DialogService, dateFormat: DateFormatPipe);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    updatePropertyName(id: string | number, name: string): void;
    triggerExpand(value: boolean): void;
    updateDateTime(value: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<JsonEditorNodeFlatComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<JsonEditorNodeFlatComponent, "ngx-json-editor-node-flat", never, { "model": { "alias": "model"; "required": false; }; "schema": { "alias": "schema"; "required": false; }; "typeCheckOverrides": { "alias": "typeCheckOverrides"; "required": false; }; "errors": { "alias": "errors"; "required": false; }; "label": { "alias": "label"; "required": false; }; "level": { "alias": "level"; "required": false; }; "schemaBuilderMode": { "alias": "schemaBuilderMode"; "required": false; }; "schemaRef": { "alias": "schemaRef"; "required": false; }; "formats": { "alias": "formats"; "required": false; }; "arrayItem": { "alias": "arrayItem"; "required": false; }; "hideRoot": { "alias": "hideRoot"; "required": false; }; "arrayName": { "alias": "arrayName"; "required": false; }; "indentationArray": { "alias": "indentationArray"; "required": false; }; "showKnownProperties": { "alias": "showKnownProperties"; "required": false; }; "isDuplicated": { "alias": "isDuplicated"; "required": false; }; "passwordToggleEnabled": { "alias": "passwordToggleEnabled"; "required": false; }; "inputControlTemplate": { "alias": "inputControlTemplate"; "required": false; }; }, { "updatePropertyNameEvent": "updatePropertyNameEvent"; }, never, ["[cdkDragHandle]", "[node-options]"], false, never>;
}
