import { TemplateRef, OnInit, SimpleChanges, OnChanges } from '@angular/core';
import { ArrayNode } from '../../../../node-types/array-node.component';
import { JSONEditorSchema, JsonSchemaDataType } from '../../../../json-editor.helper';
import { DialogService } from '../../../../../dialog/dialog.service';
import { PropertyConfigOptions, PropertyConfigComponent } from '../property-config/property-config.component';
import * as i0 from "@angular/core";
export declare class ArrayNodeFlatComponent extends ArrayNode implements OnInit, OnChanges {
    private dialogService;
    propertyConfigTmpl: TemplateRef<PropertyConfigComponent>;
    level: number;
    schemaBuilderMode: boolean;
    formats: JsonSchemaDataType[];
    hideRoot: boolean;
    isDuplicated: boolean;
    passwordToggleEnabled: boolean;
    inputControlTemplate: TemplateRef<unknown>;
    indentationArray: number[];
    constructor(dialogService: DialogService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onPropertyConfig(item: JSONEditorSchema, index: number): void;
    updateSchemaProperty(options: PropertyConfigOptions): void;
    addArrayItem(dataType?: JsonSchemaDataType): void;
    deleteArrayItem(index: number): void;
    addDefaultItemForSchemaBuilder(dataType: JsonSchemaDataType): void;
    private removeDefaultItemForSchemaBuilder;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayNodeFlatComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ArrayNodeFlatComponent, "ngx-json-array-node-flat", never, { "level": { "alias": "level"; "required": false; }; "schemaBuilderMode": { "alias": "schemaBuilderMode"; "required": false; }; "formats": { "alias": "formats"; "required": false; }; "hideRoot": { "alias": "hideRoot"; "required": false; }; "isDuplicated": { "alias": "isDuplicated"; "required": false; }; "passwordToggleEnabled": { "alias": "passwordToggleEnabled"; "required": false; }; "inputControlTemplate": { "alias": "inputControlTemplate"; "required": false; }; }, {}, never, never, false, never>;
}
