import { TemplateRef, OnInit, ChangeDetectorRef, SimpleChanges, OnChanges } from '@angular/core';
import { ObjectNode } from '../../../../node-types/object-node.component';
import { DialogService } from '../../../../../dialog/dialog.service';
import { JsonSchemaDataType, JSONEditorSchema } from '../../../../json-editor.helper';
import { CdkDragDrop } from '@angular/cdk/drag-drop';
import { PropertyConfigOptions, PropertyConfigComponent } from '../property-config/property-config.component';
import * as i0 from "@angular/core";
export declare class ObjectNodeFlatComponent extends ObjectNode implements OnInit, OnChanges {
    private dialogService;
    protected cdr: ChangeDetectorRef;
    propertyConfigTmpl: TemplateRef<PropertyConfigComponent>;
    level: number;
    schemaBuilderMode: boolean;
    formats: JsonSchemaDataType[];
    hideRoot: boolean;
    isDuplicated: boolean;
    passwordToggleEnabled: boolean;
    inputControlTemplate: TemplateRef<unknown>;
    indentationArray: number[];
    duplicatedFields: Map<string, string>;
    objectKeys: {
        (o: object): string[];
        (o: {}): string[];
    };
    get isRoot(): boolean;
    get indentAdd(): boolean;
    constructor(dialogService: DialogService, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onUpdatePropertyName(options: {
        id: string;
        name: string;
    }): void;
    onPropertyConfig(property: JSONEditorSchema, index: number, isNew?: boolean): void;
    updateSchemaProperty(options: PropertyConfigOptions): void;
    addProperty(dataType: JsonSchemaDataType): void;
    deleteProperty(propName: string): void;
    drop(event: CdkDragDrop<string[]>): void;
    private swapSchemaProperties;
    private initSchemaProperties;
    private updateSchemaRefProperty;
    private updateSchemaPropertyName;
    private toggleRequiredValue;
    private updateRequiredProperties;
    static ɵfac: i0.ɵɵFactoryDeclaration<ObjectNodeFlatComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ObjectNodeFlatComponent, "ngx-json-object-node-flat", never, { "level": { "alias": "level"; "required": false; }; "schemaBuilderMode": { "alias": "schemaBuilderMode"; "required": false; }; "formats": { "alias": "formats"; "required": false; }; "hideRoot": { "alias": "hideRoot"; "required": false; }; "isDuplicated": { "alias": "isDuplicated"; "required": false; }; "passwordToggleEnabled": { "alias": "passwordToggleEnabled"; "required": false; }; "inputControlTemplate": { "alias": "inputControlTemplate"; "required": false; }; }, {}, never, never, false, never>;
}
