import { OnInit, EventEmitter } from '@angular/core';
import { JSONEditorSchema, JsonSchemaDataType } from '../../../../json-editor.helper';
import * as i0 from "@angular/core";
export interface PropertyConfigOptions {
    required: boolean;
    index: number;
    newProperty: JSONEditorSchema;
    oldProperty: JSONEditorSchema;
}
export declare class PropertyConfigComponent implements OnInit {
    property: JSONEditorSchema;
    index?: number;
    schema: JSONEditorSchema;
    formats: JsonSchemaDataType[];
    arrayItem?: boolean;
    rootItem?: boolean;
    isNew: boolean;
    updateProperty: EventEmitter<PropertyConfigOptions>;
    propTypes: string[];
    editableProperty: JSONEditorSchema;
    required: boolean;
    isNameLocked: boolean;
    canChangeType: boolean;
    newEnumValue: string;
    ngOnInit(): void;
    applyChanges(): void;
    updateType(type: string): void;
    updateExamples(examples: string[]): void;
    updateFormat(format: string): void;
    addEnumValue(): void;
    updateDefault(enumValue: string): void;
    removeEnumValue(val: string): void;
    onTitleChange(title: string): void;
    private cleanUpPropertyConstrains;
    private setRequired;
    static ɵfac: i0.ɵɵFactoryDeclaration<PropertyConfigComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<PropertyConfigComponent, "ngx-property-config", never, { "property": { "alias": "property"; "required": false; }; "index": { "alias": "index"; "required": false; }; "schema": { "alias": "schema"; "required": false; }; "formats": { "alias": "formats"; "required": false; }; "arrayItem": { "alias": "arrayItem"; "required": false; }; "rootItem": { "alias": "rootItem"; "required": false; }; "isNew": { "alias": "isNew"; "required": false; }; }, { "updateProperty": "updateProperty"; }, never, never, false, never>;
}
