import { EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { JsonSchemaDataType, JSONEditorSchema } from '../json-editor.helper';
import * as i0 from "@angular/core";
export declare class ArrayNode implements OnChanges {
    schema: JSONEditorSchema;
    model: any[];
    required: boolean;
    expanded: boolean;
    path: string;
    errors: any[];
    typeCheckOverrides?: any;
    schemaRef: JSONEditorSchema;
    showKnownProperties: boolean;
    modelChange: EventEmitter<any[]>;
    schemaUpdate: EventEmitter<JSONEditorSchema>;
    requiredCache: any;
    schemas: JSONEditorSchema[];
    dataTypes: JsonSchemaDataType[];
    dataTypeMap: Record<string, any>;
    _array: ArrayConstructor;
    ngOnChanges(changes: SimpleChanges): void;
    /**
     * Updates an array item of the model and emits the change event
     *
     * @param index
     * @param value
     */
    updateArrayItem(index: number, value: any): void;
    /**
     * Adds a new item to the model
     */
    addArrayItem(dataType?: JsonSchemaDataType): void;
    /**
     * Deletes an item from the array
     *
     * @param index
     */
    deleteArrayItem(index: number): void;
    /**
     * Track By function for the array ittierator
     *
     * @param index
     * @param value
     */
    arrayTrackBy(index: number): number;
    /**
     *
     * @param property
     * @param type
     */
    changeItemType(index: number, type: string): void;
    private getTypeFromSchemaProperty;
    /**
     * Infers the schema type for each item in the array
     */
    private initSchemasTypeByModelValue;
    /**
     * Updates the icons in the schemas
     */
    private updateIcons;
    static ɵfac: i0.ɵɵFactoryDeclaration<ArrayNode, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ArrayNode, never, never, { "schema": { "alias": "schema"; "required": false; }; "model": { "alias": "model"; "required": false; }; "required": { "alias": "required"; "required": false; }; "expanded": { "alias": "expanded"; "required": false; }; "path": { "alias": "path"; "required": false; }; "errors": { "alias": "errors"; "required": false; }; "typeCheckOverrides": { "alias": "typeCheckOverrides"; "required": false; }; "schemaRef": { "alias": "schemaRef"; "required": false; }; "showKnownProperties": { "alias": "showKnownProperties"; "required": false; }; }, { "modelChange": "modelChange"; "schemaUpdate": "schemaUpdate"; }, never, never, true, never>;
}
