import { AfterContentInit, AfterViewInit, ElementRef, EventEmitter, OnDestroy, QueryList } from '@angular/core';
import { CdkVirtualScrollViewport } from '@angular/cdk/scrolling';
import { ListRowComponent } from './list-row/list-row.component';
import { ListColumnComponent } from './list-column/list-column.component';
import { ListHeaderComponent } from './list-header/list-header.component';
import { ListPaginationConfig } from './models/list-pagination-config';
import * as i0 from "@angular/core";
export declare class ListComponent implements AfterContentInit, AfterViewInit, OnDestroy {
    columnLayout: Partial<CSSStyleDeclaration>;
    dataSource: Array<Record<string, unknown>>;
    height: number;
    paginationConfig: ListPaginationConfig;
    virtualScroll: boolean;
    onPageChange: EventEmitter<number>;
    onScroll: EventEmitter<number>;
    row: ListRowComponent;
    columns: QueryList<ListColumnComponent>;
    headers: QueryList<ListHeaderComponent>;
    listRowsContainer: ElementRef<HTMLDivElement>;
    virtualScrollViewport: CdkVirtualScrollViewport;
    headerComponent: typeof ListHeaderComponent;
    rowComponent: typeof ListRowComponent;
    _columnLayout: Partial<CSSStyleDeclaration>;
    hasScrollbar: boolean;
    page: number;
    rowHeight: number;
    private destroy$;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    /**
     * @function emitScrollChanges
     *
     * @description
     * Emits the `onScroll` event. Additionally, if the `paginationConfig` input is provided, emits the `onPageChange` event.
     *
     * @param {Event} event - the scroll event
     */
    emitScrollChanges(event: Event): void;
    /**
     * @function generateLayout
     *
     * @description
     * Generates the column layout styling.
     */
    generateLayout(): void;
    /**
     * @function initScrollListener
     *
     * @description
     * Initializes the appropriate scroll listener.
     */
    initScrollListener(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ListComponent, "ngx-list", never, { "columnLayout": { "alias": "columnLayout"; "required": false; }; "dataSource": { "alias": "dataSource"; "required": false; }; "height": { "alias": "height"; "required": false; }; "paginationConfig": { "alias": "paginationConfig"; "required": false; }; "virtualScroll": { "alias": "virtualScroll"; "required": false; }; }, { "onPageChange": "onPageChange"; "onScroll": "onScroll"; }, ["row", "columns", "headers"], never, false, never>;
}
