import { EventEmitter, TemplateRef } from '@angular/core';
import { NotificationStyleType } from './notification-style-type.enum';
import * as i0 from "@angular/core";
export declare class NotificationComponent {
    cssClass: string;
    title: string;
    body: string;
    template: TemplateRef<any>;
    styleType: NotificationStyleType;
    icon: string;
    timeout: false | number;
    get showClose(): boolean;
    set showClose(showClose: boolean);
    get pauseOnHover(): boolean;
    set pauseOnHover(pauseOnHover: boolean);
    get timestamp(): number;
    set timestamp(timestamp: number);
    close: EventEmitter<void>;
    pause: EventEmitter<void>;
    resume: EventEmitter<void>;
    get cssClasses(): string;
    get animationDuration(): string;
    readonly NotificationStyleType: typeof NotificationStyleType;
    timer: any;
    private _showClose?;
    private _pauseOnHover?;
    private _timestamp?;
    onMouseEnter(): void;
    onMouseLeave(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NotificationComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NotificationComponent, "ngx-notification", ["ngxNotification"], { "cssClass": { "alias": "cssClass"; "required": false; }; "title": { "alias": "title"; "required": false; }; "body": { "alias": "body"; "required": false; }; "template": { "alias": "template"; "required": false; }; "styleType": { "alias": "styleType"; "required": false; }; "icon": { "alias": "icon"; "required": false; }; "timeout": { "alias": "timeout"; "required": false; }; "showClose": { "alias": "showClose"; "required": false; }; "pauseOnHover": { "alias": "pauseOnHover"; "required": false; }; "timestamp": { "alias": "timestamp"; "required": false; }; }, { "close": "close"; "pause": "pause"; "resume": "resume"; }, never, never, false, never>;
}
