import { ChangeDetectorRef, TemplateRef } from '@angular/core';
import { ProgressSpinnerMode } from './progress-spinner-mode.enum';
import * as i0 from "@angular/core";
export declare enum SpinnerAppearance {
    Default = "default",
    Icon = "icon"
}
export interface SpinnerLabel {
    inProgressLabel: string;
    completeLabel: string;
    failLabel: string;
}
export declare class ProgressSpinnerComponent {
    private readonly _cdr;
    mode: ProgressSpinnerMode;
    color: string;
    failStatusColor: string;
    appearance: SpinnerAppearance;
    inProgressIcon?: TemplateRef<any>;
    completeIcon?: TemplateRef<any>;
    failIcon?: TemplateRef<any>;
    isFailure: boolean;
    spinnerLabel?: SpinnerLabel;
    get value(): number;
    set value(v: number);
    get total(): number;
    set total(t: number);
    get diameter(): number;
    set diameter(d: number);
    get strokeWidth(): number;
    set strokeWidth(s: number);
    get radius(): number;
    get strokeDasharray(): string;
    get strokeDashoffset(): number;
    get percentage(): number;
    get isComplete(): boolean;
    get indeterminateClass(): boolean;
    get spinnerColor(): string;
    get showIcon(): boolean;
    readonly uid: string;
    readonly ProgressSpinnerMode: typeof ProgressSpinnerMode;
    private _value;
    private _total;
    private _diameter;
    private _strokeWidth;
    private readonly _indeterminate;
    private get _circumference();
    private get _modeValue();
    private get _modeTotal();
    constructor(_cdr: ChangeDetectorRef);
    static ɵfac: i0.ɵɵFactoryDeclaration<ProgressSpinnerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ProgressSpinnerComponent, "ngx-progress-spinner", ["ngxProgressSpinner"], { "mode": { "alias": "mode"; "required": false; }; "color": { "alias": "color"; "required": false; }; "failStatusColor": { "alias": "failStatusColor"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "inProgressIcon": { "alias": "inProgressIcon"; "required": false; }; "completeIcon": { "alias": "completeIcon"; "required": false; }; "failIcon": { "alias": "failIcon"; "required": false; }; "isFailure": { "alias": "isFailure"; "required": false; }; "spinnerLabel": { "alias": "spinnerLabel"; "required": false; }; "value": { "alias": "value"; "required": false; }; "total": { "alias": "total"; "required": false; }; "diameter": { "alias": "diameter"; "required": false; }; "strokeWidth": { "alias": "strokeWidth"; "required": false; }; "spinnerColor": { "alias": "spinnerColor"; "required": false; }; }, {}, never, never, false, never>;
}
