import { EventEmitter, OnDestroy, AfterContentInit, ChangeDetectorRef, OnChanges } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { RadioButtonComponent } from './radiobutton.component';
import type { QueryList } from '@angular/core';
import * as i0 from "@angular/core";
export declare class RadioButtonGroupComponent implements ControlValueAccessor, OnDestroy, OnChanges, AfterContentInit {
    private readonly _cdr;
    readonly UNIQUE_ID: string;
    id: string;
    get disabled(): boolean;
    set disabled(val: boolean);
    get value(): any;
    set value(value: any);
    get name(): string;
    set name(name: string);
    get focusIndex(): number;
    set focusIndex(val: number);
    get tabIndex(): number;
    set tabIndex(val: number);
    change: EventEmitter<boolean>;
    blur: EventEmitter<Event>;
    focus: EventEmitter<FocusEvent>;
    readonly _radios: QueryList<RadioButtonComponent>;
    get selected(): RadioButtonComponent;
    private _name;
    private _value;
    private _disabled;
    private _selected;
    private _focusIndex;
    private _tabIndex;
    private _destroy$;
    constructor(_cdr: ChangeDetectorRef);
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(): void;
    onFocus(): void;
    onKeyUp(ev: KeyboardEvent): void;
    subscribeToRadios(): void;
    onRadioSelected(value: string): void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    onChangeCallback(_: any): void;
    onTouchedCallback(): void;
    focusFirst(): void;
    setDisabledState(isDisabled: boolean): void;
    private selectIndex;
    private focusOn;
    /**
     * Moves focus to next radio button in the group.
     * +1 is next radio button, -1 is previous radio button.
     */
    private focusIn;
    private update;
    private _updateRadioButtonNames;
    private _updateSelectedRadioFromValue;
    private _updateRadioDisabledState;
    static ɵfac: i0.ɵɵFactoryDeclaration<RadioButtonGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<RadioButtonGroupComponent, "ngx-radiobutton-group", ["ngxRadiobuttonGroup"], { "id": { "alias": "id"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "value": { "alias": "value"; "required": false; }; "name": { "alias": "name"; "required": false; }; "focusIndex": { "alias": "focusIndex"; "required": false; }; "tabIndex": { "alias": "tabIndex"; "required": false; }; }, { "change": "change"; "blur": "blur"; "focus": "focus"; }, ["_radios"], ["*"], false, never>;
}
