import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, TemplateRef } from '@angular/core';
import { InViewportDirective } from 'ng-in-viewport';
import { SelectDropdownOption } from './select-dropdown-option.interface';
import * as i0 from "@angular/core";
export declare class SelectDropdownComponent implements AfterViewInit {
    private readonly elementRef;
    private readonly cdr;
    selected: any[];
    identifier: any;
    filterPlaceholder: string;
    filterEmptyPlaceholder: string;
    emptyPlaceholder: string;
    allowAdditionsText: string | TemplateRef<any>;
    tagging: boolean;
    allowAdditions: boolean;
    filterable: boolean;
    filterCaseSensitive: boolean;
    showSelectAll: boolean;
    get focusIndex(): number;
    set focusIndex(val: number);
    get filterQuery(): string;
    set filterQuery(val: string);
    get groupBy(): string;
    set groupBy(val: string);
    groupByTemplate: TemplateRef<unknown>;
    get options(): SelectDropdownOption[];
    set options(val: SelectDropdownOption[]);
    keyup: EventEmitter<{
        event: KeyboardEvent;
        value?: string;
    }>;
    selection: EventEmitter<SelectDropdownOption>;
    selectAll: EventEmitter<void>;
    deselection: EventEmitter<SelectDropdownOption>;
    keyboardSelection: EventEmitter<SelectDropdownOption>;
    keyboardDeselection: EventEmitter<SelectDropdownOption>;
    close: EventEmitter<boolean>;
    clearQueryFilter: EventEmitter<void>;
    readonly filterInput?: ElementRef<HTMLInputElement>;
    readonly inViewport: InViewportDirective;
    get element(): any;
    get isNotTemplate(): boolean;
    get hasAvailableOptions(): boolean;
    groups: any[];
    filterQueryIsInOptions: boolean;
    private _options;
    private _groupBy;
    private _filterQuery;
    private _focusIndex;
    constructor(elementRef: ElementRef, cdr: ChangeDetectorRef);
    ngAfterViewInit(): void;
    isSelected(option: SelectDropdownOption): boolean;
    updateFilterQueryIsInOptions(): void;
    clearFilter(filterInput: HTMLInputElement): void;
    onInputKeyUp(event: KeyboardEvent): void;
    onOptionClick(option: SelectDropdownOption): void;
    onOptionKeyDown(event: KeyboardEvent, option?: SelectDropdownOption): void;
    focusNext(): void;
    focusPrev(): void;
    onAddClicked(event: Event, value: any): void;
    onShiftEnterKeyDown(event: any): void;
    onTabKeyDown(event: any): void;
    focusOn(index: number): void;
    private focusElement;
    private calculateGroups;
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectDropdownComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SelectDropdownComponent, "ngx-select-dropdown", ["ngxSelectDropdown"], { "selected": { "alias": "selected"; "required": false; }; "identifier": { "alias": "identifier"; "required": false; }; "filterPlaceholder": { "alias": "filterPlaceholder"; "required": false; }; "filterEmptyPlaceholder": { "alias": "filterEmptyPlaceholder"; "required": false; }; "emptyPlaceholder": { "alias": "emptyPlaceholder"; "required": false; }; "allowAdditionsText": { "alias": "allowAdditionsText"; "required": false; }; "tagging": { "alias": "tagging"; "required": false; }; "allowAdditions": { "alias": "allowAdditions"; "required": false; }; "filterable": { "alias": "filterable"; "required": false; }; "filterCaseSensitive": { "alias": "filterCaseSensitive"; "required": false; }; "showSelectAll": { "alias": "showSelectAll"; "required": false; }; "focusIndex": { "alias": "focusIndex"; "required": false; }; "filterQuery": { "alias": "filterQuery"; "required": false; }; "groupBy": { "alias": "groupBy"; "required": false; }; "groupByTemplate": { "alias": "groupByTemplate"; "required": false; }; "options": { "alias": "options"; "required": false; }; }, { "keyup": "keyup"; "selection": "selection"; "selectAll": "selectAll"; "deselection": "deselection"; "keyboardSelection": "keyboardSelection"; "keyboardDeselection": "keyboardDeselection"; "close": "close"; "clearQueryFilter": "clearQueryFilter"; }, never, never, false, never>;
}
