import { AfterViewInit, ElementRef, EventEmitter, OnChanges, SimpleChanges, TemplateRef } from '@angular/core';
import { SelectDropdownOption } from './select-dropdown-option.interface';
import * as i0 from "@angular/core";
export declare class SelectInputComponent implements AfterViewInit, OnChanges {
    selectId: string;
    placeholder: string;
    identifier: string;
    options: SelectDropdownOption[];
    label: string;
    hint: string;
    selectCaret: string | TemplateRef<any>;
    requiredIndicator: string | boolean;
    tabindex: number;
    autofocus: boolean;
    allowClear: boolean;
    multiple: boolean;
    tagging: boolean;
    allowAdditions: boolean;
    disableDropdown: boolean;
    disabled: boolean;
    get selected(): any[];
    set selected(val: any[]);
    toggle: EventEmitter<void>;
    close: EventEmitter<void>;
    selection: EventEmitter<any[]>;
    activate: EventEmitter<void>;
    activateLast: EventEmitter<void>;
    keyup: EventEmitter<{
        event: KeyboardEvent;
        value?: string;
    }>;
    readonly inputContainer?: ElementRef<HTMLElement>;
    readonly inputElement?: ElementRef<HTMLInputElement>;
    get caretVisible(): boolean;
    get clearVisible(): boolean;
    get hasControls(): boolean;
    get isNotTemplate(): boolean;
    selectedOptions: SelectDropdownOption[];
    private _selected;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    onInputKeyDown(event: KeyboardEvent): void;
    onInputKeyUp(event: KeyboardEvent): void;
    clearInput(): void;
    onGlobalKeyUp(event: KeyboardEvent): void;
    onKeyDown(event: KeyboardEvent): void;
    onClick(): void;
    onFocus(): void;
    onToggle(_ev?: PointerEvent): void;
    onClear(ev?: PointerEvent): void;
    onOptionRemove(event: Event, option: SelectDropdownOption): void;
    onClearTaggingInput(ev?: PointerEvent): void;
    focus(): void;
    private calcSelectedOptions;
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SelectInputComponent, "ngx-select-input", ["ngxSelectInput"], { "selectId": { "alias": "selectId"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "identifier": { "alias": "identifier"; "required": false; }; "options": { "alias": "options"; "required": false; }; "label": { "alias": "label"; "required": false; }; "hint": { "alias": "hint"; "required": false; }; "selectCaret": { "alias": "selectCaret"; "required": false; }; "requiredIndicator": { "alias": "requiredIndicator"; "required": false; }; "tabindex": { "alias": "tabindex"; "required": false; }; "autofocus": { "alias": "autofocus"; "required": false; }; "allowClear": { "alias": "allowClear"; "required": false; }; "multiple": { "alias": "multiple"; "required": false; }; "tagging": { "alias": "tagging"; "required": false; }; "allowAdditions": { "alias": "allowAdditions"; "required": false; }; "disableDropdown": { "alias": "disableDropdown"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "selected": { "alias": "selected"; "required": false; }; }, { "toggle": "toggle"; "close": "close"; "selection": "selection"; "activate": "activate"; "activateLast": "activateLast"; "keyup": "keyup"; }, never, ["ngx-input-hint"], false, never>;
}
