import { EventEmitter, AfterContentInit, ChangeDetectorRef, OnDestroy } from '@angular/core';
import type { QueryList } from '@angular/core';
import { TabComponent } from './tab.component';
import { TabsAppearance } from './tabs-appearance.enum';
import * as i0 from "@angular/core";
export declare class TabsComponent implements AfterContentInit, OnDestroy {
    readonly cdr: ChangeDetectorRef;
    get light(): boolean;
    vertical: boolean;
    selectTab: EventEmitter<any>;
    select: EventEmitter<any>;
    appearance: TabsAppearance;
    readonly tabs: QueryList<TabComponent>;
    get horizontalClass(): boolean;
    get verticalClass(): boolean;
    private tabEvents;
    get index(): number;
    private readonly _destroy$;
    constructor(cdr: ChangeDetectorRef);
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    tabClicked(activeTab: TabComponent): void;
    move(offset: number): void;
    next(): void;
    prev(): void;
    private setupTabInputWatcher;
    static ɵfac: i0.ɵɵFactoryDeclaration<TabsComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TabsComponent, "ngx-tabs", ["ngxTabs"], { "vertical": { "alias": "vertical"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; }, { "selectTab": "selectTab"; "select": "select"; }, ["tabs"], ["*"], false, never>;
}
