import { OnChanges, OnInit } from '@angular/core';
import { Clipboard } from '@angular/cdk/clipboard';
import moment from 'moment-timezone';
import { NotificationService } from '../notification/notification.service';
import { DATE_DISPLAY_TYPES } from '../../enums/date-formats.enum';
import { Datelike } from '../date-time/date-like.type';
import * as i0 from "@angular/core";
export declare class NgxTimeDisplayComponent implements OnInit, OnChanges {
    private readonly clipboard;
    private readonly notificationService;
    datetime: Datelike;
    precision: moment.unitOfTime.StartOf;
    timezone: string;
    defaultInputTimeZone: string;
    set mode(val: DATE_DISPLAY_TYPES);
    get mode(): DATE_DISPLAY_TYPES;
    set type(val: string);
    get type(): string;
    set format(val: string);
    get format(): string;
    set tooltipFormat(val: string);
    get tooltipFormat(): string;
    set clipFormat(val: string);
    get clipFormat(): string;
    timezones: Record<string, string>;
    tooltipTemplate: string;
    tooltipDisabled: boolean;
    tooltipCssClass: string;
    tooltipPlacement: string;
    defaultCopyKey: string;
    invalidDateMessage: string;
    get clickable(): boolean;
    set clickable(val: boolean);
    get hasPopup(): boolean;
    dateInvalid: boolean;
    timeValues: {};
    titleValue: string;
    internalDatetime: Date;
    utcDatetime: string;
    readonly DATE_DISPLAY_TYPES: typeof DATE_DISPLAY_TYPES;
    readonly DATE_DISPLAY_FORMATS: {
        shortDate: string;
        shortTime: string;
        shortDateTime: string;
        shortDateTimeSeconds: string;
        date: string;
        time: string;
        dateTime: string;
        dateTimeSeconds: string;
        dateMonth: string;
        dateYear: string;
        fullDate: string;
        fullTime: string;
        fullDateTime: string;
        fullDateMonth: string;
        fullDateYear: string;
        localeDate: string;
        localeDateTime: string;
        localeTime: string;
        timezoneDate: string;
        timezoneDateTime: string;
        timezoneDateTimeSeconds: string;
        timezoneTime: string;
        timezoneDateMonth: string;
        timezoneDateYear: string;
        locale: string;
        shortLocale: string;
        fullLocale: string;
    };
    private _mode;
    private _format;
    private _tooltipFormat;
    private _clipFormat;
    private _clickable;
    private _type;
    constructor(clipboard: Clipboard, notificationService: NotificationService);
    ngOnInit(): void;
    ngOnChanges(): void;
    click(): void;
    onClick(item: any): void;
    private update;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxTimeDisplayComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxTimeDisplayComponent, "ngx-time", never, { "datetime": { "alias": "datetime"; "required": false; }; "precision": { "alias": "precision"; "required": false; }; "timezone": { "alias": "timezone"; "required": false; }; "defaultInputTimeZone": { "alias": "defaultInputTimeZone"; "required": false; }; "mode": { "alias": "mode"; "required": false; }; "type": { "alias": "type"; "required": false; }; "format": { "alias": "format"; "required": false; }; "tooltipFormat": { "alias": "tooltipFormat"; "required": false; }; "clipFormat": { "alias": "clipFormat"; "required": false; }; "timezones": { "alias": "timezones"; "required": false; }; "tooltipTemplate": { "alias": "tooltipTemplate"; "required": false; }; "tooltipDisabled": { "alias": "tooltipDisabled"; "required": false; }; "tooltipCssClass": { "alias": "tooltipCssClass"; "required": false; }; "tooltipPlacement": { "alias": "tooltipPlacement"; "required": false; }; "defaultCopyKey": { "alias": "defaultCopyKey"; "required": false; }; "invalidDateMessage": { "alias": "invalidDateMessage"; "required": false; }; "clickable": { "alias": "clickable"; "required": false; }; }, {}, never, never, false, never>;
}
