import { AfterViewInit, ElementRef, Renderer2, TemplateRef } from '@angular/core';
import { AlignmentTypes } from '../../utils/position/alignment-types.enum';
import { PlacementTypes } from '../../utils/position/placement-type.enum';
import { StyleTypes } from './style-types.enum';
import * as i0 from "@angular/core";
export declare class TooltipContentComponent implements AfterViewInit {
    readonly element: ElementRef<HTMLElement>;
    private readonly renderer;
    readonly caretElm: ElementRef<HTMLSpanElement>;
    host: ElementRef<HTMLElement>;
    type: StyleTypes;
    placement: PlacementTypes;
    alignment: AlignmentTypes;
    cssClass: string;
    title: string;
    template: TemplateRef<any>;
    context: any;
    get showCaret(): boolean;
    set showCaret(val: boolean);
    get spacing(): number;
    set spacing(val: number);
    private _spacing;
    private _showCaret;
    get hostElement(): HTMLElement;
    get cssClasses(): string;
    constructor(element: ElementRef<HTMLElement>, renderer: Renderer2);
    ngAfterViewInit(): void;
    onWindowResize(): void;
    position(): void;
    private positionContent;
    private positionCaret;
    private checkFlip;
    static ɵfac: i0.ɵɵFactoryDeclaration<TooltipContentComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TooltipContentComponent, "ngx-tooltip-content", ["ngxTooltipContent"], { "host": { "alias": "host"; "required": false; }; "type": { "alias": "type"; "required": false; }; "placement": { "alias": "placement"; "required": false; }; "alignment": { "alias": "alignment"; "required": false; }; "cssClass": { "alias": "cssClass"; "required": false; }; "title": { "alias": "title"; "required": false; }; "template": { "alias": "template"; "required": false; }; "context": { "alias": "context"; "required": false; }; "showCaret": { "alias": "showCaret"; "required": false; }; "spacing": { "alias": "spacing"; "required": false; }; }, {}, never, never, false, never>;
}
