import { EventEmitter, TemplateRef, ChangeDetectorRef, OnDestroy, AfterContentInit, OnChanges, SimpleChanges } from '@angular/core';
import type { QueryList } from '@angular/core';
import { TreeNodeComponent } from './tree-node.component';
import { TreeNode } from './tree-node.model';
import * as i0 from "@angular/core";
export declare class TreeComponent implements AfterContentInit, OnDestroy, OnChanges {
    private readonly _cdr;
    nodes: TreeNode[];
    virtualScrolling: boolean;
    maxVirtualScrollHeight: number;
    nodeHeight: number;
    _templateInput: TemplateRef<any>;
    icons: {
        collapse: string;
        expand: string;
    };
    _templateQuery: TemplateRef<any>;
    readonly nodeElms: QueryList<TreeNodeComponent>;
    readonly allNodeElms: QueryList<TreeNodeComponent>;
    expand: EventEmitter<any>;
    collapse: EventEmitter<any>;
    activate: EventEmitter<any>;
    deactivate: EventEmitter<any>;
    selectNode: EventEmitter<any>;
    get hasOneLeaf(): boolean;
    get template(): TemplateRef<any>;
    treeStructure: TreeNode[];
    filteredTree: TreeNode[];
    depthPadding: number;
    private readonly _destroy$;
    constructor(_cdr: ChangeDetectorRef);
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onExpand(event: any): void;
    onCollapse(event: any): void;
    applyTreeChanges(tree: TreeNode[]): void;
    filterTree(tree: TreeNode[]): void;
    generateTreeStructure(nodes: TreeNode[]): TreeNode[];
    applyExpandChange(nodes: TreeNode[]): TreeNode[];
    generateAditionalTreeInfo(nodes: TreeNode[]): void;
    elementsToNodes(nodes: QueryList<TreeNodeComponent>): TreeNode[];
    trackBy(_index: number, node: any): number;
    filled(node: TreeNode, filteredTree: TreeNode[], isSingle?: boolean): boolean;
    empty(node: TreeNode, filteredTree: TreeNode[]): boolean;
    dots(node: TreeNode, filteredTree: TreeNode[]): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<TreeComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TreeComponent, "ngx-tree", never, { "nodes": { "alias": "nodes"; "required": false; }; "virtualScrolling": { "alias": "virtualScrolling"; "required": false; }; "maxVirtualScrollHeight": { "alias": "maxVirtualScrollHeight"; "required": false; }; "nodeHeight": { "alias": "nodeHeight"; "required": false; }; "_templateInput": { "alias": "template"; "required": false; }; "icons": { "alias": "icons"; "required": false; }; }, { "expand": "expand"; "collapse": "collapse"; "activate": "activate"; "deactivate": "deactivate"; "selectNode": "selectNode"; }, ["_templateQuery", "nodeElms", "allNodeElms"], ["*"], false, never>;
}
